defmodule AoC.Input do
  defp get_session!(), do: File.read!("./.session") |> String.trim()
  defp get_request_headers!(), do: [Cookie: "session=#{get_session!()}"]
  defp get_url(year, day), do: "https://adventofcode.com/#{year}/day/#{day}/input"

  def fetch_input!(year, day) do
    HTTPoison.start()

    get_url(year, day)
      |> HTTPoison.get!(
        get_request_headers!()
      )
      |> Map.get(:body)
  end
end
